## openiked 6.9.0

=== CMakeLists.txt ===
# Copyright (c) 2020-2021 Tobias Heider <tobhe@openbsd.org>
#
# Permission to use, copy, modify, and distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

cmake_minimum_required(VERSION 3.12)

project(openiked)

include(CheckFunctionExists)
include(CheckLibraryExists)
include(CheckSymbolExists)
include(CheckIncludeFiles)

include_directories("/usr/local/include")
link_directories("/usr/local/lib")

if (CMAKE_SYSTEM_NAME MATCHES "Darwin")
	if (NOT DEFINED CMAKE_INSTALL_SYSCONFDIR)
		set (CMAKE_INSTALL_SYSCONFDIR /etc)
	endif()
	include_directories("/usr/local/opt/openssl@1.1/include")
	link_directories("/usr/local/opt/openssl@1.1/lib")
elseif(CMAKE_SYSTEM_NAME MATCHES "OpenBSD")
	if (NOT DEFINED CMAKE_INSTALL_SYSCONFDIR)
		set (CMAKE_INSTALL_SYSCONFDIR /etc)
	endif()
	add_definitions(-DHAVE_ATTRIBUTE__BOUNDED__)
	add_definitions(-DHAVE_ATTRIBUTE__DEAD__)
	add_definitions(-DHAVE_SOCKADDR_SA_LEN)
	set(HAVE_VROUTE ON)
elseif(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
	if (NOT DEFINED CMAKE_INSTALL_SYSCONFDIR)
		set (CMAKE_INSTALL_SYSCONFDIR ${CMAKE_INSTALL_PREFIX}/etc)
	endif()
	add_definitions(-DIKED_CONFIG="${CMAKE_INSTALL_SYSCONFDIR}/iked.conf")
	add_definitions(-DIKED_CA="${CMAKE_INSTALL_SYSCONFDIR}/iked/")
	add_definitions(-DHAVE_SOCKADDR_SA_LEN)
	set(HAVE_VROUTE ON)
elseif(CMAKE_SYSTEM_NAME MATCHES "NetBSD")
	if (NOT DEFINED CMAKE_INSTALL_SYSCONFDIR)
		set (CMAKE_INSTALL_SYSCONFDIR /etc)
	endif()
	add_definitions(-DHAVE_SOCKADDR_SA_LEN)
	add_definitions(-D_OPENBSD_SOURCE)
	set(HAVE_VROUTE ON)
elseif(CMAKE_SYSTEM_NAME MATCHES "Linux")
	if (NOT DEFINED CMAKE_INSTALL_SYSCONFDIR)
		set (CMAKE_INSTALL_SYSCONFDIR /etc)
	endif()
	if (NOT DEFINED CMAKE_INSTALL_MANDIR)
		set (CMAKE_INSTALL_MANDIR /usr/share/man)
	endif()
	add_definitions(-D_GNU_SOURCE)
	add_definitions(-D_DEFAULT_SOURCE)
	add_definitions(-DHAVE_UDPENCAP6)
	add_definitions(-DSPT_TYPE=SPT_REUSEARGV)
	set(HAVE_VROUTE_NETLINK ON)
endif()
if (NOT DEFINED CMAKE_INSTALL_MANDIR)
	set (CMAKE_INSTALL_MANDIR ${CMAKE_INSTALL_PREFIX}/man)
endif()

check_include_files("sys/types.h;net/pfkeyv2.h" HAVE_NET_PFKEY_H)
if(HAVE_NET_PFKEY_H)
	add_definitions(-DHAVE_NET_PFKEY_H)
endif()

check_include_files("linux/pfkeyv2.h" HAVE_LINUX_PFKEY_H)
if(HAVE_LINUX_PFKEY_H)
	add_definitions(-DHAVE_LINUX_PFKEY_H)
endif()

if(CMAKE_BUILD_TYPE STREQUAL DEBUG)
	message("Debug build.")
elseif(CMAKE_BUILD_TYPE STREQUAL RELEASE)
	message("Release build.")
endif()

check_include_files(unistd.h HAVE_UNISTD_H)
if(HAVE_UNISTD_H)
	add_definitions(-DHAVE_UNISTD_H)
endif()

check_include_files(dirent.h HAVE_DIRENT_H)
if(HAVE_DIRENT_H)
	add_definitions(-DHAVE_DIRENT_H)
endif()

check_include_files(grp.h HAVE_GRP_H)
if(HAVE_GRP_H)
	add_definitions(-DHAVE_GRP_H)
endif()

check_include_files("sys/socket.h;netinet/ip_ipsp.h" HAVE_IPSP_H)
if(HAVE_IPSP_H)
	add_definitions(-DHAVE_IPSP_H)
endif()

check_include_files("sys/types.h;netipsec/ipsec.h" HAVE_NET_IPSEC_H)
if(HAVE_NET_IPSEC_H)
	add_definitions(-DHAVE_NET_IPSEC_H)
endif()

check_include_files("netinet6/ipsec.h" HAVE_NETINET6_IPSEC_H)
if(HAVE_NETINET6_IPSEC_H)
	add_definitions(-DHAVE_NETINET6_IPSEC_H)
endif()

check_include_files("linux/ipsec.h" HAVE_LINUX_IPSEC_H)
if(HAVE_LINUX_IPSEC_H)
	add_definitions(-DHAVE_LINUX_IPSEC_H)
endif()

check_include_files("sys/types.h;sys/queue.h;imsg.h" HAVE_IMSG_H)
if(HAVE_IMSG_H)
	add_definitions(-DHAVE_IMSG_H)
endif()

check_function_exists(recallocarray HAVE_RECALLOCARRAY)
if(HAVE_RECALLOCARRAY)
	add_definitions(-DHAVE_RECALLOCARRAY)
endif()

check_function_exists(reallocarray HAVE_REALLOCARRAY)
if(HAVE_REALLOCARRAY)
	add_definitions(-DHAVE_REALLOCARRAY)
endif()

check_function_exists(accept4 HAVE_ACCEPT4)
if(HAVE_ACCEPT4)
	add_definitions(-DHAVE_ACCEPT4)
endif()

check_symbol_exists(SOCK_NONBLOCK "sys/socket.h" HAVE_SOCK_NONBLOCK)
if(HAVE_SOCK_NONBLOCK)
	add_definitions(-DHAVE_SOCK_NONBLOCK)
endif()

check_function_exists(setproctitle HAVE_SETPROCTITLE)
if(HAVE_SETPROCTITLE)
	add_definitions(-DHAVE_SETPROCTITLE)
endif()

check_function_exists(pledge HAVE_PLEDGE)
if(HAVE_PLEDGE)
	add_definitions(-DHAVE_PLEDGE)
endif()

check_function_exists(setresgid HAVE_SETRESGID)
if(HAVE_SETRESGID)
	add_definitions(-DHAVE_SETRESGID)
endif()

check_function_exists(setresuid HAVE_SETRESUID)
if(HAVE_SETRESUID)
	add_definitions(-DHAVE_SETRESUID)
endif()

check_function_exists(setregid HAVE_SETREGID)
if(HAVE_SETREGID)
	add_definitions(-DHAVE_SETREGID)
endif()

check_function_exists(setreuid HAVE_SETREUID)
if(HAVE_SETREUID)
	add_definitions(-DHAVE_SETREUID)
endif()

check_function_exists(getrtable HAVE_GETRTABLE)
if(HAVE_GETRTABLE)
	add_definitions(-DHAVE_GETRTABLE)
endif()

# setrtable
check_function_exists(setrtable HAVE_SETRTABLE)
if(HAVE_SETRTABLE)
	add_definitions(-DHAVE_SETRTABLE)
endif()

check_function_exists(strtonum HAVE_STRTONUM)
if(HAVE_STRTONUM)
	add_definitions(-DHAVE_STRTONUM)
endif()

check_symbol_exists(ifgroupreq "net/if.h" HAVE_IFGROUPREQ)
if(HAVE_IFGROUPREQ)
	add_definitions(-DHAVE_IFGROUPREQ)
endif()

check_function_exists(freezero HAVE_FREEZERO)
if(HAVE_FREEZERO)
	add_definitions(-DHAVE_FREEZERO)
endif()

check_function_exists(getdtablecount HAVE_GETDTABLECOUNT)
if(HAVE_GETDTABLECOUNT)
	add_definitions(-DHAVE_GETDTABLECOUNT)
endif()

check_symbol_exists(timespecsub "sys/time.h" HAVE_TIMESPECSUB)
if(HAVE_TIMESPECSUB)
	add_definitions(-DHAVE_TIMESPECSUB)
endif()

check_function_exists(asprintf HAVE_ASPRINTF)
if(HAVE_ASPRINTF)
	add_definitions(-DHAVE_ASPRINTF)
endif()

check_function_exists(strcasecmp HAVE_STRCASECMP)
if(HAVE_STRCASECMP)
	add_definitions(-DHAVE_STRCASECMP)
endif()

check_function_exists(strlcat HAVE_STRLCAT)
if(HAVE_STRLCAT)
	add_definitions(-DHAVE_STRLCAT)
endif()

check_function_exists(strlcpy HAVE_STRLCPY)
if(HAVE_STRLCPY)
	add_definitions(-DHAVE_STRLCPY)
endif()

check_function_exists(strndup HAVE_STRNDUP)
if(HAVE_STRNDUP)
	add_definitions(-DHAVE_STRNDUP)
endif()

check_function_exists(ffs HAVE_FFS)
if(HAVE_FFS)
	add_definitions(-DHAVE_FFS)
endif()

check_function_exists(strnlen HAVE_STRNLEN)
if(HAVE_STRNLEN)
	add_definitions(-DHAVE_STRNLEN)
endif()

check_function_exists(strsep HAVE_STRSEP)
if(HAVE_STRSEP)
	add_definitions(-DHAVE_STRSEP)
endif()

check_function_exists(timegm HAVE_TIMEGM)
if(HAVE_TIMEGM)
	add_definitions(-DHAVE_TIMEGM)
endif()

check_function_exists(arc4random_buf HAVE_ARC4RANDOM_BUF)
if(HAVE_ARC4RANDOM_BUF)
	add_definitions(-DHAVE_ARC4RANDOM_BUF)
endif()

check_function_exists(arc4random_uniform HAVE_ARC4RANDOM_UNIFORM)
if(HAVE_ARC4RANDOM_UNIFORM)
	add_definitions(-DHAVE_ARC4RANDOM_UNIFORM)
endif()

check_function_exists(explicit_bzero HAVE_EXPLICIT_BZERO)
if(HAVE_EXPLICIT_BZERO)
	add_definitions(-DHAVE_EXPLICIT_BZERO)
endif()

check_function_exists(getauxval HAVE_GETAUXVAL)
if(HAVE_GETAUXVAL)
	add_definitions(-DHAVE_GETAUXVAL)
endif()

check_function_exists(getentropy HAVE_GETENTROPY)
if(HAVE_GETENTROPY)
	add_definitions(-DHAVE_GETENTROPY)
endif()

check_symbol_exists(getpagesize unistd.h HAVE_GETPAGESIZE)
if(HAVE_GETPAGESIZE)
	add_definitions(-DHAVE_GETPAGESIZE)
endif()

check_function_exists(getprogname HAVE_GETPROGNAME)
if(HAVE_GETPROGNAME)
	add_definitions(-DHAVE_GETPROGNAME)
endif()

check_function_exists(syslog_r HAVE_SYSLOG_R)
if(HAVE_SYSLOG_R)
	add_definitions(-DHAVE_SYSLOG_R)
endif()

check_function_exists(syslog HAVE_SYSLOG)
if(HAVE_SYSLOG)
	add_definitions(-DHAVE_SYSLOG)
endif()

check_function_exists(vis HAVE_VIS)
if(HAVE_VIS)
	add_definitions(-DHAVE_VIS)
endif()

check_symbol_exists(timespecsub sys/time.h HAVE_TIMESPECSUB)
if(HAVE_TIMESPECSUB)
	add_definitions(-DHAVE_TIMESPECSUB)
endif()

check_function_exists(timingsafe_bcmp HAVE_TIMINGSAFE_BCMP)
if(HAVE_TIMINGSAFE_BCMP)
	add_definitions(-DHAVE_TIMINGSAFE_BCMP)
endif()

check_function_exists(timingsafe_memcmp HAVE_TIMINGSAFE_MEMCMP)
if(HAVE_MEMCMP)
	add_definitions(-DHAVE_MEMCMP)
endif()

check_function_exists(memmem HAVE_MEMMEM)
if(HAVE_MEMMEM)
	add_definitions(-DHAVE_MEMMEM)
endif()

check_include_files(err.h HAVE_ERR_H)
if(HAVE_ERR_H)
	add_definitions(-DHAVE_ERR_H)
endif()

check_function_exists(usleep HAVE_USLEEP)
if(HAVE_USLEEP)
	add_definitions(-DHAVE_USLEEP)
endif()

check_function_exists(getopt HAVE_GETOPT)
if(HAVE_GETOPT)
        add_definitions(-DHAVE_GETOPT)
endif()
if(HAVE_VROUTE)
	add_definitions(-DHAVE_VROUTE)
endif()
if(HAVE_VROUTE_NETLINK)
	add_definitions(-DHAVE_VROUTE_NETLINK)
endif()

add_subdirectory(compat)
add_subdirectory(iked)
add_subdirectory(ikectl)
add_subdirectory(regress/dh)
add_subdirectory(regress/parser)
if(CMAKE_SYSTEM_NAME MATCHES "Linux" AND CMAKE_C_COMPILER_ID STREQUAL "Clang")
	add_subdirectory(regress/parser-libfuzzer)
endif()
add_subdirectory(regress/test_helper)

=== iked/Makefile ===
# $OpenBSD: Makefile,v 1.21 2021/03/05 22:03:51 tobhe Exp $

PROG=		iked
SRCS=		ca.c chap_ms.c config.c control.c crypto.c dh.c \
		eap.c iked.c ikev2.c ikev2_msg.c ikev2_pld.c \
		log.c ocsp.c pfkey.c policy.c print.c proc.c timer.c util.c \
		imsg_util.c smult_curve25519_ref.c vroute.c
SRCS+=		eap_map.c ikev2_map.c
SRCS+=		parse.y
SRCS+=		ipsec.c
MAN=		iked.conf.5 iked.8
#NOMAN=		yes

LDADD=		-lutil -levent -lcrypto
DPADD=		${LIBUTIL} ${LIBEVENT} ${LIBCRYPTO}
CFLAGS+=	-Wall -I${.CURDIR}
CFLAGS+=	-Wstrict-prototypes -Wmissing-prototypes
CFLAGS+=	-Wmissing-declarations
CFLAGS+=	-Wshadow -Wpointer-arith -Wcast-qual
CFLAGS+=	-Wsign-compare
CLEANFILES+=	ikev2_map.c eap_map.c
GENERATED=	ikev2_map.c eap_map.c

YFLAGS=

ikev2_map.c: genmap.sh ikev2.h
	/bin/sh ${.CURDIR}/genmap.sh ${.CURDIR}/ikev2.h ikev2 > $@
	@touch $@

eap_map.c: genmap.sh eap.h
	/bin/sh ${.CURDIR}/genmap.sh ${.CURDIR}/eap.h eap > $@
	@touch $@

.include <bsd.prog.mk>

# Don't compile iked as static binary by default
LDSTATIC=

=== debian/changelog ===
openiked (6.9.0-1) unstable; urgency=medium

  * New upstream release
    + Sufficiently stable to upload to unstable
  * Set debian-branch to debian/unstable
  * Drop unneeded README.source

 -- Ryan Kavanagh <rak@debian.org>  Sat, 08 May 2021 17:38:43 -0400

openiked (0.0.0~git20210409.9ff0f77-1) experimental; urgency=medium

  * New upstream release

 -- Ryan Kavanagh <rak@debian.org>  Fri, 09 Apr 2021 10:47:48 -0400

openiked (0.0.0~git20210320.2bbd41e-1) experimental; urgency=medium

  * New upstream release

 -- Ryan Kavanagh <rak@debian.org>  Sat, 20 Mar 2021 15:22:29 -0400

openiked (0.0.0~git20210206.e4ff75f-1) experimental; urgency=medium

  * New upstream release

 -- Ryan Kavanagh <rak@debian.org>  Sat, 06 Feb 2021 14:16:52 -0500

openiked (0.0.0~git20210203.6bdcf9f-1) experimental; urgency=medium

  * New upstream release
  * Drop debian/manpages: upstream now installs man pages

 -- Ryan Kavanagh <rak@debian.org>  Wed, 03 Feb 2021 17:58:52 -0500

openiked (0.0.0~git20210123.2e52b4d-1) experimental; urgency=medium

  * Initial release. (Closes: #980882)

 -- Ryan Kavanagh <rak@debian.org>  Sat, 23 Jan 2021 20:40:59 -0500

=== debian/control ===
Source: openiked
Section: net
Priority: optional
Maintainer: Ryan Kavanagh <rak@debian.org>
Build-Depends: bison,
               cmake,
               debhelper-compat (= 13),
               libevent-dev,
               libssl-dev,
Standards-Version: 4.5.1
Homepage: https://www.openiked.org/
Vcs-Browser: https://salsa.debian.org/debian/openiked
Vcs-Git: https://salsa.debian.org/debian/openiked.git -b debian/unstable
Rules-Requires-Root: no

Package: openiked
Architecture: any
Pre-Depends: ${misc:Pre-Depends},
Depends: adduser,
         openssl,
         ${misc:Depends},
         ${shlibs:Depends},
Description: Internet Key Exchange (IKEv2) daemon
 A free implementation of the Internet Key Exchange (IKEv2) protocol
 which performs mutual authentication and which establishes and maintains
 IPsec VPN security policies and associations (SAs) between peers. It is
 intended to be a lean, clean, secure, better configurable and
 interoperable implementation that focusses on supporting the main
 standards and most important features of IKEv2.

=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

# There are no upstream tarballs yet

## openiked 7.0

=== compat/CMakeLists.txt ===
# Copyright (c) 2020-2021 Tobias Heider <tobhe@openbsd.org>
#
# Permission to use, copy, modify, and distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

set(IKED_COMPAT		"${CMAKE_CURRENT_SOURCE_DIR}")
set(SRCS)

if(NOT HAVE_RECALLOCARRAY)
	list(APPEND SRCS ${IKED_COMPAT}/recallocarray.c)
endif()
if(NOT HAVE_SOCK_NONBLOCK)
	list(APPEND SRCS ${IKED_COMPAT}/bsd-socket.c)
endif()
if(NOT HAVE_SETRESUID)
	list(APPEND SRCS ${IKED_COMPAT}/bsd-setres_id.c)
endif()
if(NOT HAVE_GETRTABLE)
	list(APPEND SRCS ${IKED_COMPAT}/getrtable.c)
endif()
if(NOT HAVE_GETDTABLECOUNT)
	list(APPEND SRCS ${IKED_COMPAT}/getdtablecount.c)
endif()
if(NOT HAVE_SETPROCTITLE)
	list(APPEND SRCS ${IKED_COMPAT}/setproctitle.c)
endif()
if(NOT HAVE_STRTONUM)
	list(APPEND SRCS ${IKED_COMPAT}/strtonum.c)
endif()
if(NOT HAVE_FFS)
	list(APPEND SRCS ${IKED_COMPAT}/ffs.c)
endif()
if(NOT HAVE_GETOPT)
	list(APPEND SRCS ${IKED_COMPAT}/getopt_long.c)
endif()
if(NOT HAVE_IMSG_H)
	list(APPEND SRCS
		# imsg
		${IKED_COMPAT}/imsg.c
		${IKED_COMPAT}/imsg-buffer.c
	)
endif()
if(NOT HAVE_STRLCPY)
	list(APPEND SRCS ${IKED_COMPAT}/strlcpy.c)
endif()
if(NOT HAVE_STRLCAT)
	list(APPEND SRCS ${IKED_COMPAT}/strlcat.c)
endif()
if(NOT HAVE_FREEZERO)
	list(APPEND SRCS ${IKED_COMPAT}/freezero.c)
endif()
if(NOT HAVE_ARC4RANDOM_BUF)
	list(APPEND SRCS ${IKED_COMPAT}/arc4random.c)
endif()
if(NOT HAVE_ARC4RANDOM_UNIFORM)
	list(APPEND SRCS ${IKED_COMPAT}/arc4random_uniform.c)
endif()
if(NOT HAVE_EXPLICIT_BZERO)
	list(APPEND SRCS ${IKED_COMPAT}/explicit_bzero.c)
endif()
if(NOT HAVE_REALLOCARRAY)
	list(APPEND SRCS ${IKED_COMPAT}/reallocarray.c)
endif()
if(NOT HAVE_VIS)
	list(APPEND SRCS ${IKED_COMPAT}/vis.c)
endif()

set(CFLAGS)
list(APPEND CFLAGS
	-O2
	-Wall
	-Wno-pointer-sign
	-Wno-deprecated-declarations
	-Wstrict-prototypes
	-Wmissing-prototypes
	-Wmissing-declarations
	-Wshadow
	-Wpointer-arith
	-Wcast-qual
	-Wsign-compare
	"$<$<CONFIG:DEBUG>:-O0;-g>"
)

if(SRCS)
	add_library(compat OBJECT ${SRCS})
	target_compile_options(compat PRIVATE ${CFLAGS})
	target_include_directories(compat PUBLIC .)
else()
	add_library(compat INTERFACE)
	target_include_directories(compat INTERFACE .)
endif()

=== ikectl/CMakeLists.txt ===
# Copyright (c) 2020-2021 Tobias Heider <tobhe@openbsd.org>
#
# Permission to use, copy, modify, and distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

set(SRCS)
list(APPEND SRCS
	ikeca.c
	ikectl.c
	parser.c
	# iked
	${CMAKE_CURRENT_SOURCE_DIR}/../iked/log.c
	${CMAKE_CURRENT_SOURCE_DIR}/../iked/util.c
)

add_executable(ikectl ${SRCS})

set(CFLAGS)
list(APPEND CFLAGS
	-O2
	-Wall
	-Wno-pointer-sign
	-Wno-deprecated-declarations
	-Wstrict-prototypes
	-Wmissing-prototypes
	-Wmissing-declarations
	-Wshadow
	-Wpointer-arith
	-Wcast-qual
	-Wsign-compare
	"$<$<CONFIG:DEBUG>:-O0;-g>"
)

target_compile_options(ikectl PRIVATE ${CFLAGS})

target_include_directories(ikectl
	PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}
		${CMAKE_CURRENT_SOURCE_DIR}/../iked
)

target_link_libraries(ikectl
	PRIVATE util event crypto ssl compat
)

install(TARGETS ikectl RUNTIME DESTINATION sbin)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/ikectl.8 DESTINATION ${CMAKE_INSTALL_MANDIR}/man8/)

=== iked/CMakeLists.txt ===
# Copyright (c) 2020-2021 Tobias Heider <tobhe@openbsd.org>
#
# Permission to use, copy, modify, and distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

include(CheckFunctionExists)
include(CheckLibraryExists)
include(CheckSymbolExists)
include(CheckIncludeFiles)

set(VERSIONED_FILES)
list(APPEND VERSIONED_FILES iked.c)

set(SRCS)

set(CFLAGS)
list(APPEND CFLAGS
	-O2
	-Wall
	-Wno-pointer-sign
	-Wno-deprecated-declarations
	-Wstrict-prototypes
	-Wmissing-prototypes
	-Wmissing-declarations
	-Wshadow
	-Wpointer-arith
	-Wcast-qual
	-Wsign-compare
	"$<$<CONFIG:DEBUG>:-O0;-g>"
)

set(INC_DIRS
	${CMAKE_CURRENT_SOURCE_DIR}
	${CMAKE_CURRENT_SOURCE_DIR}/../iked
)

add_library(iked-shared OBJECT
	ikev2_pld.c
	imsg_util.c
	log.c
	util.c
	${CMAKE_CURRENT_BINARY_DIR}/ikev2_map.c
	${CMAKE_CURRENT_BINARY_DIR}/eap_map.c
)

if(CMAKE_SYSTEM_NAME MATCHES "OpenBSD")
	list(APPEND SRCS ipsec.c pfkey.c)
elseif(CMAKE_SYSTEM_NAME MATCHES "Linux")
	list(APPEND SRCS ipsec.c pfkey.c)
elseif(CMAKE_SYSTEM_NAME MATCHES "Darwin")
	list(APPEND SRCS ipsec.c pfkey.c)
elseif(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
	list(APPEND SRCS ipsec.c pfkey.c)
elseif(CMAKE_SYSTEM_NAME MATCHES "NetBSD")
	list(APPEND SRCS ipsec.c pfkey.c)
endif()
if(HAVE_VROUTE)
	list(APPEND SRCS vroute.c)
endif()
if(HAVE_VROUTE_NETLINK)
	list(APPEND SRCS vroute-netlink.c)
endif()

list(APPEND SRCS
	ca.c
	chap_ms.c
	config.c
	control.c
	crypto.c
	dh.c
	eap.c
	iked.c
	ikev2.c
	ikev2.h
	ikev2_msg.c
	ocsp.c
	policy.c
	print.c
	proc.c
	smult_curve25519_ref.c
	timer.c
	crypto_hash.c
	sntrup761.c
	# Generated files
	${CMAKE_CURRENT_BINARY_DIR}/parse.c
)

add_executable(iked ${SRCS})

target_compile_options(iked PRIVATE ${CFLAGS})
target_compile_options(iked-shared PRIVATE ${CFLAGS})

target_include_directories(iked PRIVATE ${INC_DIRS})
target_include_directories(iked-shared PRIVATE ${INC_DIRS})

target_link_libraries(iked-shared
	PRIVATE util event crypto ssl compat
)
target_link_libraries(iked
	PRIVATE util event crypto ssl compat iked-shared
)

add_custom_command(
	OUTPUT parse.c
	COMMAND yacc -o parse.c ${CMAKE_CURRENT_SOURCE_DIR}/parse.y
	DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/parse.y
)

add_custom_command(
	OUTPUT ikev2_map.c
	COMMAND sh ${CMAKE_CURRENT_SOURCE_DIR}/genmap.sh
	    ${CMAKE_CURRENT_SOURCE_DIR}/ikev2.h ikev2 > ikev2_map.c
	DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/ikev2.h
	DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/genmap.sh
)

add_custom_command(
	OUTPUT eap_map.c
	COMMAND sh ${CMAKE_CURRENT_SOURCE_DIR}/genmap.sh
	    ${CMAKE_CURRENT_SOURCE_DIR}/eap.h eap > eap_map.c
	DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/eap.h
	DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/genmap.sh
)

install(TARGETS iked RUNTIME DESTINATION sbin)
install(FILES ${CMAKE_SOURCE_DIR}/iked.conf
	PERMISSIONS OWNER_READ OWNER_WRITE 
	DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}
)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/iked.conf.5 DESTINATION ${CMAKE_INSTALL_MANDIR}/man5/)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/iked.8 DESTINATION ${CMAKE_INSTALL_MANDIR}/man8/)
install(DIRECTORY DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/iked/ca)
install(DIRECTORY DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/iked/certs)
install(DIRECTORY DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/iked/crls)
install(DIRECTORY
	DIRECTORY_PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE
	DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/iked/private
)
install(DIRECTORY DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/iked/pubkeys/ipv4)
install(DIRECTORY DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/iked/pubkeys/ipv6)
install(DIRECTORY DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/iked/pubkeys/fqdn)
install(DIRECTORY DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/iked/pubkeys/ufqdn)

=== regress/Makefile ===
#	$OpenBSD: Makefile,v 1.3 2020/01/16 11:41:14 bluhm Exp $

SUBDIR=	test_helper dh parser live

.include <bsd.subdir.mk>

=== regress/live/Makefile ===
#	$OpenBSD: Makefile,v 1.28 2020/12/17 00:51:12 bluhm Exp $

# Copyright (c) 2020 Tobias Heider <tobhe@openbsd.org>
#
# Permission to use, copy, modify, and distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

REGRESS_SETUP_ONCE =	setup
REGRESS_CLEANUP =	cleanup
CLEANFILES =		*.conf *.cnf *.csr *.key *.crt *.srl

LEFT_SSH ?=
RIGHT_SSH ?=
LEFT_ADDR ?=
RIGHT_ADDR ?=

.if empty(LEFT_SSH) || empty(RIGHT_SSH) || empty(LEFT_ADDR) || empty(RIGHT_ADDR)
regress:
	@echo this test needs two remote machines to operate
	@echo LEFT_SSH RIGHT_SSH RIGHT_ADDR LEFT_ADDR are not defined
	@echo SKIPPED
.endif

TEST_FLOWS = \
	[ -z $$tmode ] && tmode=tunnel; \
	_ret=1; \
	count=0; \
	dynamic=${RIGHT_ADDR}; \
	if [ "$$config_address" = true ]; then \
		dynamic="172.16.13.37"; \
	fi; \
	while [[ $$count -le 3 ]]; do \
		ipsecctlleft=`ssh ${LEFT_SSH} ipsecctl -sa`; \
		ipsecctlright=`ssh ${RIGHT_SSH} ipsecctl -sa`; \
		flowleft=`echo "$$ipsecctlleft" \
		    | sed -E -n "/^flow $$flowtype in from $$dynamic\
		    to ${LEFT_ADDR} peer ${RIGHT_ADDR} srcid (FQDN|UFQDN|ASN1_DN)\/[^ ]*\
		    dstid (FQDN|UFQDN|ASN1_DN)\/[^ ]*/p"`; \
		flowright=`echo "$$ipsecctlright" \
		    | sed -E -n "/^flow $$flowtype in from ${LEFT_ADDR}\
		    to $$dynamic peer ${LEFT_ADDR} srcid (FQDN|UFQDN|ASN1_DN)\/[^ ]*\
		    dstid (FQDN|UFQDN|ASN1_DN)\/[^ ]*/p"`; \
		saleft_rtol=`echo "$$ipsecctlleft" \
		    | sed -n "/^$$flowtype $$tmode from ${RIGHT_ADDR} to ${LEFT_ADDR}/p"`; \
		saleft_ltor=`echo "$$ipsecctlleft" \
		    | sed -n "/^$$flowtype $$tmode from ${LEFT_ADDR} to ${RIGHT_ADDR}/p"`; \
		saright_rtol=`echo "$$ipsecctlright" \
		    | sed -n "/^$$flowtype $$tmode from ${RIGHT_ADDR} to ${LEFT_ADDR}/p"`; \
		saright_ltor=`echo "$$ipsecctlright" \
		    | sed -n "/^$$flowtype $$tmode from ${LEFT_ADDR} to ${RIGHT_ADDR}/p"`; \
		if [[ -n "$$saleft_ltor" && -n "$$saleft_rtol" && \
		     -n "$$saright_ltor" && -n "$$saright_rtol" && \
		     -n "$$flowleft" && -n "$$flowright" ]]; then \
			 _ret=0; \
			 break; \
		fi; \
		let count=$$count+1; \
	done; \
	if [[ "$${_ret}" -ne 0 ]]; then \
		echo "SAs not found:\n$$ipsecctlleft\n$$ipsecctlright"; \
	fi

TEST_PING = \
	_ret=1; \
	if [[ "${IPV}" == "6" ]]; then ping="ping6"; else ping="ping"; fi; \
	dump=`ssh ${LEFT_SSH} "tcpdump -n -c2 -i enc0 -w /tmp/test.pcap > /dev/null & \
	    $$ping -w 1 -n -c 5 ${RIGHT_ADDR} > /dev/null && \
	    tcpdump -n -r /tmp/test.pcap && rm -f /tmp/test.pcap; \
	    kill -9 \\$$! > /dev/null 2>&1 || true"`; \
	rtol=`echo "$$dump" \
	    | sed -n "/(authentic,confidential): SPI 0x[0-9a-f]\{8\}: ${LEFT_ADDR} > ${RIGHT_ADDR}/p"`; \
	ltor=`echo "$$dump" \
	    | sed -n "/(authentic,confidential): SPI 0x[0-9a-f]\{8\}: ${RIGHT_ADDR} > ${LEFT_ADDR}/p"`; \
	if [[ -z "$$rtol" || -z "$$ltor" ]]; then \
		_ret=1; \
	else \
		_ret=0; \
	fi; \
	echo "$$dump"

TEST_SINGLEIKESA = \
	count=`ssh ${LEFT_SSH} "ikectl show sa | grep -c iked_sas"`; \
	if [[ "$$count" != "1" ]]; then \
		echo "error: too many IKE SAs."; \
		exit 1; \
	fi

SETUP_CONFIG = \
	from=$$local; \
	to=$$peer; \
	if [[ -z "$$mode" ]]; then mode="active"; fi; \
	authstr=""; \
	if [[ "$$auth" = "psk" ]]; then \
		authstr="psk $$psk"; \
	fi; \
	ipcomp=""; \
	if [[ "$$flowtype" = "ipcomp" ]]; then \
		ipcomp="ipcomp"; \
	fi; \
	global=""; \
	if [ "$$fragmentation" = true ]; then \
		global="$${global}set fragmentation\n"; \
	fi; \
	if [ "$$singleikesa" = true ]; then \
		global="$${global}set enforcesingleikesa\n"; \
	fi; \
	confstr=""; \
	if [ "$$config_address" = true ]; then \
		if [ "$$side" = left ]; then \
			mode=passive; \
			confstr="config address 172.16.13.36/31"; \
			to="dynamic"; \
		else \
			mode=active; \
			confstr="request address any"; \
			from="dynamic"; \
		fi; \
	fi; \
	echo "MODE=\"$$mode\"" >> $@_$$side.conf; \
	echo "TMODE=\"$$tmode\"" >> $@_$$side.conf; \
	echo "FROM=\"$$from\"" >> $@_$$side.conf; \
	echo "TO=\"$$to\"" >> $@_$$side.conf; \
	echo "LOCAL_ADDR=\"$$local\"" >> $@_$$side.conf; \
	echo "PEER_ADDR=\"$$peer\"" >> $@_$$side.conf; \
	echo "IPCOMP=\"$$ipcomp\"" >> $@_$$side.conf; \
	echo "SRCID=\"\\\"$$srcid\\\"\"" >> $@_$$side.conf; \
	echo "DSTID=\"$$dstid\"" >> $@_$$side.conf; \
	echo "AUTH=\"$$authstr\"" >> $@_$$side.conf; \
	echo "CONFIG=\"$$confstr\"" >> $@_$$side.conf; \
	echo "$$global" >> $@_$$side.conf; \
	cat ${.CURDIR}/iked.in >> $@_$$side.conf

DEPLOY_CONFIGS = \
	chmod 0600 $@_left.conf; \
	echo "cd /tmp\nput $@_left.conf test.conf" | sftp -q ${LEFT_SSH}; \
	chmod 0600 $@_right.conf; \
	echo "cd /tmp\nput $@_right.conf test.conf" | sftp -q ${RIGHT_SSH}; \
	rm -f $@_left.conf $@_right.conf

SETUP_CONFIGS = \
	if [[ "$$auth" = "psk" ]]; then \
		psk=`openssl rand -hex 20`; \
	fi; \
	side=left; \
	srcid=$$leftid; \
	local=${LEFT_ADDR}; \
	peer=${RIGHT_ADDR}; \
	    ${SETUP_CONFIG}; \
	side=right; \
	srcid=$$rightid; \
	local=${RIGHT_ADDR}; \
	peer=${LEFT_ADDR}; \
	    ${SETUP_CONFIG}; \
	${DEPLOY_CONFIGS}

SETUP_SYSCTL = \
	ssh ${LEFT_SSH} "sysctl $$sysctl"; \
	ssh ${RIGHT_SSH} "sysctl $$sysctl"

SETUP_START = \
	ssh ${LEFT_SSH} "ipsecctl -F; pkill iked; iked $$iked_flags -f /tmp/test.conf"; \
	ssh ${RIGHT_SSH} "ipsecctl -F; pkill iked; iked $$iked_flags -f /tmp/test.conf"

SETUP_RELOAD_RIGHT = \
	ssh ${RIGHT_SSH} "ikectl reload"

SETUP_CERT = \
	echo "ALTNAME = $$name-from-$$caname" > $$name-from-$$caname.cnf; \
	cat ${.CURDIR}/crt.in >> $$name-from-$$caname.cnf; \
	openssl req -config $$name-from-$$caname.cnf -new -key $$name.key -nodes \
	    -out $$name-from-$$caname.csr; \
	openssl x509 -extfile $$name-from-$$caname.cnf -extensions req_cert_extensions \
	     -req -in $$name-from-$$caname.csr -CA $$caname.crt -CAkey $$caname.key \
	     -CAcreateserial -out $$name-from-$$caname.crt

SETUP_CA = \
	openssl genrsa -out $$caname.key 2048; \
	openssl req -subj "/C=DE/ST=Bavaria/L=Munich/O=iked/CN=$$caname" \
	     -new -x509 -key $$caname.key -out $$caname.crt

cleanup:
	-ssh ${LEFT_SSH} 'rm -f /tmp/test.conf; ipsecctl -F; pkill iked; \
	    rm -f /etc/iked/ca/*; rm -f /etc/iked/certs/*; rm -f /etc/iked/private/*; \
	    sysctl "net.inet.esp.udpencap_port=4500"; \
	    rm -f /tmp/pf.conf; pfctl -d; pfctl -f /etc/pf.conf;'
	-ssh ${RIGHT_SSH} 'rm -f /tmp/test.conf; ipsecctl -F; pkill iked; \
	    rm -f /etc/iked/ca/*; rm -f /etc/iked/certs/*; rm -f /etc/iked/private/*; \
	    sysctl "net.inet.esp.udpencap_port=4500"; \
	    rm -f /tmp/pf.conf; pfctl -d; pfctl -f /etc/pf.conf;'

setup_certs: ca-both.crt left-from-ca-both.crt left.key right-from-ca-both.crt \
    right.key ca-left.crt right-from-ca-left.crt ca-right.crt left-from-ca-right.crt
	echo "cd /etc/iked\n \
	    put left-from-ca-both.crt certs\n \
	    put left-from-ca-right.crt certs\n \
	    put left.key private/local.key\n \
	    put ca-left.crt ca\n \
	    put ca-both.crt ca\n" | sftp ${LEFT_SSH} -q; \
	echo "cd /etc/iked\n \
	    put right-from-ca-both.crt certs\n \
	    put right-from-ca-left.crt certs\n \
	    put right.key private/local.key\n \
	    put ca-right.crt ca\n \
	    put ca-both.crt ca\n" | sftp ${RIGHT_SSH} -q; \
	ssh ${LEFT_SSH} "openssl rsa -in /etc/iked/private/local.key -pubout > /etc/iked/local.pub"; \
	ssh ${RIGHT_SSH} "openssl rsa -in /etc/iked/private/local.key -pubout > /etc/iked/local.pub"

setup_pf: pf.in
	echo "cd /tmp\nput ${.CURDIR}/pf.in pf.conf" | sftp -q ${LEFT_SSH}
	echo "cd /tmp\nput ${.CURDIR}/pf.in pf.conf" | sftp -q ${RIGHT_SSH}
	-ssh ${LEFT_SSH} "pfctl -f /tmp/pf.conf; pfctl -e"
	-ssh ${RIGHT_SSH} "pfctl -f /tmp/pf.conf; pfctl -e"

setup: setup_pf setup_certs

.PHONY: setup_certs

test_flows:
	${TEST_FLOWS}

left.key right.key:
	openssl genrsa -out $@ 2048

ca-both.crt ca-both.key:
	caname=ca-both; ${SETUP_CA}

left-from-ca-both.crt: ca-both.crt ca-both.key left.key
	caname=ca-both; name=left; ${SETUP_CERT}

right-from-ca-both.crt: ca-both.crt ca-both.key right.key
	caname=ca-both; name=right; ${SETUP_CERT}

ca-left.crt ca-left.key:
	caname=ca-left; ${SETUP_CA}

right-from-ca-left.crt right.key: ca-left.crt ca-left.key
	caname=ca-left; name=right; ${SETUP_CERT}

ca-right.crt ca-right.key:
	caname=ca-right; ${SETUP_CA}

left-from-ca-right.crt left.key: ca-right.crt ca-right.key
	caname=ca-right; name=left; ${SETUP_CERT}

REGRESS_TARGETS = run-ping-fail
run-ping-fail:
	ssh ${LEFT_SSH} "ipsecctl -F; pkill iked || true"
	ssh ${RIGHT_SSH} "ipsecctl -F; pkill iked || true"
	${TEST_PING}; \
	if [[ $$_ret -ne 1 ]]; then exit 1; fi

REGRESS_TARGETS += run-cert-single-ca
run-cert-single-ca:
	leftid=left-from-ca-both; \
	rightid=right-from-ca-both; \
	    ${SETUP_CONFIGS}
	${SETUP_START}
	flowtype=esp; ${TEST_FLOWS}; if [[ $$_ret -ne 0 ]]; then exit 1; fi
	${TEST_PING}; if [[ $$_ret -ne 0 ]]; then exit 1; fi

REGRESS_TARGETS += run-cert-single-ca-asn1dn
run-cert-single-ca-asn1dn:
	leftid="/C=DE/ST=Bavaria/L=Munich/O=iked/CN=left-from-ca-both"; \
	rightid="/C=DE/ST=Bavaria/L=Munich/O=iked/CN=right-from-ca-both"; \
	    ${SETUP_CONFIGS}
	${SETUP_START}
	flowtype=esp; ${TEST_FLOWS}; if [[ $$_ret -ne 0 ]]; then exit 1; fi
	${TEST_PING}; if [[ $$_ret -ne 0 ]]; then exit 1; fi

REGRESS_TARGETS += run-config-address
run-config-address:
	flowtype=esp; \
	config_address=true; \
	leftid=left-from-ca-both; \
	rightid=right-from-ca-both; \
	    ${SETUP_CONFIGS}
	${SETUP_START}
	config_address=true; \
	flowtype=esp; ${TEST_FLOWS}; if [[ $$_ret -ne 0 ]]; then exit 1; fi

REGRESS_TARGETS += run-dstid-fail
run-dstid-fail:
	leftid=left-from-ca-both; \
	rightid=right-from-ca-both; \
	    side=left; \
	    srcid=$$leftid; \
	    local=${LEFT_ADDR}; \
	    peer=${RIGHT_ADDR}; \
	    ${SETUP_CONFIG}; \
	    side=right; \
	    mode=passive; \
	    srcid=$$rightid; \
	    local=${RIGHT_ADDR}; \
	    peer=${LEFT_ADDR}; \
	    dstid="dstid invalid"; \
	    ${SETUP_CONFIG}; \
	    ${DEPLOY_CONFIGS}
	${SETUP_START}
	flowtype=esp; ${TEST_FLOWS}; if [[ $$_ret -ne 1 ]]; then exit 1; fi
	${TEST_PING}; if [[ $$_ret -ne 1 ]]; then exit 1; fi

REGRESS_TARGETS += run-dstid
run-dstid:
	flowtype=esp; \
	leftid=left-from-ca-both; \
	rightid=right-from-ca-both; \
	    side=left; \
	    srcid=$$leftid; \
	    local=${LEFT_ADDR}; \
	    peer=${RIGHT_ADDR}; \
	    dstid="dstid $$rightid"; \
	    ${SETUP_CONFIG}; \
	    side=right; \
	    srcid=$$rightid; \
	    local=${RIGHT_ADDR}; \
	    peer=${LEFT_ADDR}; \
	    dstid="dstid $$leftid"; \
	    ${SETUP_CONFIG}; \
	    ${DEPLOY_CONFIGS}
	${SETUP_START}
	flowtype=esp; ${TEST_FLOWS}; if [[ $$_ret -ne 0 ]]; then exit 1; fi
	${TEST_PING}; if [[ $$_ret -ne 0 ]]; then exit 1; fi

REGRESS_TARGETS += run-dstid-multi
run-dstid-multi:
	flowtype=esp; \
	leftid=left-from-ca-both; \
	rightid=right-from-ca-both; \
	    side=left; srcid=$$leftid; local=${LEFT_ADDR}; peer=${RIGHT_ADDR}; \
	    dstid="dstid $$rightid"; \
	    ${SETUP_CONFIG}; \
	    side=right; mode=passive; srcid=$$rightid; local=${RIGHT_ADDR}; \
	    peer=${LEFT_ADDR}; dstid="dstid $$leftid"; \
	    ${SETUP_CONFIG}; \
	    dstid="dstid roflol"; \
	    ${SETUP_CONFIG}; \
	    ${DEPLOY_CONFIGS}
	${SETUP_START}
	flowtype=esp; ${TEST_FLOWS}; if [[ $$_ret -ne 0 ]]; then exit 1; fi
	${TEST_PING}; if [[ $$_ret -ne 0 ]]; then exit 1; fi

REGRESS_TARGETS += run-cert-multi-ca
run-cert-multi-ca:
	flowtype=esp; \
	leftid=left-from-ca-right; \
	rightid=right-from-ca-left; \
	    ${SETUP_CONFIGS}
	${SETUP_START}
	flowtype=esp; ${TEST_FLOWS}; if [[ $$_ret -ne 0 ]]; then exit 1; fi

=== regress/parser-libfuzzer/CMakeLists.txt ===
# Copyright (c) 2020-2021 Tobias Heider <tobhe@openbsd.org>
#
# Permission to use, copy, modify, and distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

set(CMAKE_C_COMPILER clang)

# address-sanitizer not working on OpenBSD
set(CMAKE_C_FLAGS "-g -O1 -fsanitize=fuzzer,address")
set(CMAKE_EXE_LINKER_FLAGS "-fsanitize=fuzzer,address")

set(SRCS)
list(APPEND SRCS
	common.c
	test_parser_fuzz.c
)

add_executable(test_libfuzzer ${SRCS})

target_include_directories(test_libfuzzer
	PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/../../iked
)

target_link_libraries(test_libfuzzer
	PRIVATE util event crypto ssl compat iked-shared
)

target_compile_options(test_libfuzzer PRIVATE ${CFLAGS})

file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/corpus)
configure_file(run_test.sh run_test.sh COPYONLY)
configure_file(fuzz.dict fuzz.dict COPYONLY)

=== regress/parser-libfuzzer/Makefile ===
#	$OpenBSD: Makefile,v 1.2 2017/05/30 15:36:13 bluhm Exp $

WARNINGS=Yes

# libfuzzer needs clang
CC = clang

PROG=		test_parser
SRCS=		common.c test_parser_fuzz.c
IKEOBJS=	ikev2_pld.o imsg_util.o log.o util.o \
		ikev2_map.o eap_map.o
CLEANFILES=	${IKEOBJS}

LDADD+=		-lutil -lcrypto ${IKEOBJS} -fsanitize=fuzzer
DPADD+=		${LIBUTIL} ${LIBCRYPTO}
CFLAGS+=	-I${.CURDIR}/../../../../sbin/iked
CFLAGS+=	-g -O1 -fsanitize=fuzzer
CFLAGS+=	-Wno-missing-field-initializers

test_parser: ${IKEOBJS}

${IKEOBJS}:
	cd ${.CURDIR}/../../../../sbin/iked && make $@
	ln -sf ${.OBJDIR}/../../../../sbin/iked/$@ .

LDADD+=		-L${.OBJDIR}

.include <bsd.regress.mk>

=== debian/changelog ===
openiked (7.0-1build1) jammy; urgency=medium

  * No-change rebuild against openssl3

 -- Simon Chopin <simon.chopin@canonical.com>  Mon, 29 Nov 2021 16:04:21 +0100

openiked (7.0-1) unstable; urgency=medium

  * New upstream release
  * Update watch file to point to tarballs on FTP mirror

 -- Ryan Kavanagh <rak@debian.org>  Thu, 04 Nov 2021 12:32:35 -0400

openiked (6.9.0-2) unstable; urgency=medium

  * Bump standards version to 4.6.0
  * Delete files under /etc/iked created by openiked on purge

 -- Ryan Kavanagh <rak@debian.org>  Sat, 18 Sep 2021 21:27:42 -0400

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
                debhelper-compat (= 13),
                libevent-dev,
                libssl-dev,
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Homepage: https://www.openiked.org/
 Vcs-Browser: https://salsa.debian.org/debian/openiked
 Vcs-Git: https://salsa.debian.org/debian/openiked.git -b debian/unstable

## openiked 7.1

=== debian/changelog ===
openiked (7.1-1build1) kinetic; urgency=medium

  * No-change rebuild against libevent-2.1-7a (LP: #1990941)

 -- Benjamin Drung <bdrung@ubuntu.com>  Fri, 07 Oct 2022 19:54:06 +0200

openiked (7.1-1) unstable; urgency=medium

  * New upstream release
  * Bump copyright years

 -- Ryan Kavanagh <rak@debian.org>  Mon, 23 May 2022 14:28:57 -0400

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: openiked
 Section: net
 Priority: optional
-Maintainer: Ryan Kavanagh <rak@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Ryan Kavanagh <rak@debian.org>
 Build-Depends: bison,
                cmake,
                debhelper-compat (= 13),

## openiked 7.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (c) 2020-2021 Tobias Heider <tobhe@openbsd.org>
+# Copyright (c) 2020-2022 Tobias Heider <tobhe@openbsd.org>
 #
 # Permission to use, copy, modify, and distribute this software for any
 # purpose with or without fee is hereby granted, provided that the above
@@ -20,16 +20,29 @@
 include(CheckLibraryExists)
 include(CheckSymbolExists)
 include(CheckIncludeFiles)
+include(CheckLinkerFlag)
 
 include_directories("/usr/local/include")
 link_directories("/usr/local/lib")
 
 if (CMAKE_SYSTEM_NAME MATCHES "Darwin")
 	if (NOT DEFINED CMAKE_INSTALL_SYSCONFDIR)
-		set (CMAKE_INSTALL_SYSCONFDIR /etc)
-	endif()
-	include_directories("/usr/local/opt/openssl@1.1/include")
-	link_directories("/usr/local/opt/openssl@1.1/lib")
+		set (CMAKE_INSTALL_SYSCONFDIR ${CMAKE_INSTALL_PREFIX}/etc)
+	endif()
+	add_definitions(-DIKED_CONFIG="${CMAKE_INSTALL_SYSCONFDIR}/iked.conf")
+	add_definitions(-DIKED_CA="${CMAKE_INSTALL_SYSCONFDIR}/iked/")
+	add_definitions(-DHAVE_APPLE_NATT)
+	add_definitions(-DHAVE_SOCKADDR_SA_LEN)
+	if (HOMEBREW AND CMAKE_HOST_SYSTEM_PROCESSOR MATCHES "arm64")
+		include_directories("/opt/homebrew/include")
+		link_directories("/opt/homebrew/lib")
+		include_directories("/opt/homebrew/opt/openssl@1.1/include")
+        	link_directories("/opt/homebrew/opt/openssl@1.1/lib")
+	else()
+		include_directories("/usr/local/opt/openssl@1.1/include")
+		link_directories("/usr/local/opt/openssl@1.1/lib")
+	endif()
+	set(HAVE_VROUTE ON)
 elseif(CMAKE_SYSTEM_NAME MATCHES "OpenBSD")
 	if (NOT DEFINED CMAKE_INSTALL_SYSCONFDIR)
 		set (CMAKE_INSTALL_SYSCONFDIR /etc)
@@ -65,10 +78,13 @@
 	add_definitions(-DHAVE_UDPENCAP6)
 	add_definitions(-DSPT_TYPE=SPT_REUSEARGV)
 	set(HAVE_VROUTE_NETLINK ON)
+	set(HAVE_SYSTEMD ON)
 endif()
 if (NOT DEFINED CMAKE_INSTALL_MANDIR)
 	set (CMAKE_INSTALL_MANDIR ${CMAKE_INSTALL_PREFIX}/man)
 endif()
+
+check_linker_flag(C "LINKER:-z,now,-z,relro" HAVE_LD_Z)
 
 check_include_files("sys/types.h;net/pfkeyv2.h" HAVE_NET_PFKEY_H)
 if(HAVE_NET_PFKEY_H)
@@ -341,11 +357,25 @@
 if(HAVE_GETOPT)
         add_definitions(-DHAVE_GETOPT)
 endif()
-if(HAVE_VROUTE)
+if(HAVE_SYSTEMD)
+	add_definitions(-DHAVE_SYSTEMD)
+endif()
+if(HAVE_VROUTE OR HAVE_VROUTE_NETLINK)
 	add_definitions(-DHAVE_VROUTE)
 endif()
-if(HAVE_VROUTE_NETLINK)
-	add_definitions(-DHAVE_VROUTE_NETLINK)
+if(WITH_APPARMOR)
+	add_definitions(-DWITH_APPARMOR)
+endif()
+
+if(ASAN)
+	message("Using ASAN")
+	string(APPEND CMAKE_C_FLAGS " -fno-omit-frame-pointer -fsanitize=address")
+	string(APPEND CMAKE_LINKER_FLAGS " -fno-omit-frame-pointer -fsanitize=address")
+endif()
+if(UBSAN)
+	message("Using UBSAN")
+	string(APPEND CMAKE_C_FLAGS " -fno-omit-frame-pointer -fsanitize=undefined")
+	string(APPEND CMAKE_LINKER_FLAGS " -fno-omit-frame-pointer -fsanitize=undefined")
 endif()
 
 add_subdirectory(compat)
@@ -353,7 +383,7 @@
 add_subdirectory(ikectl)
 add_subdirectory(regress/dh)
 add_subdirectory(regress/parser)
-if(CMAKE_SYSTEM_NAME MATCHES "Linux" AND CMAKE_C_COMPILER_ID STREQUAL "Clang")
+if(CLUSTERFUZZ)
 	add_subdirectory(regress/parser-libfuzzer)
 endif()
 add_subdirectory(regress/test_helper)

=== compat/CMakeLists.txt ===
--- 
+++ 
@@ -77,6 +77,9 @@
 set(CFLAGS)
 list(APPEND CFLAGS
 	-O2
+	-fstack-protector-strong
+	-fPIE
+	-D_FORTIFY_SOURCE=2
 	-Wall
 	-Wno-pointer-sign
 	-Wno-deprecated-declarations

=== ikectl/CMakeLists.txt ===
--- 
+++ 
@@ -27,6 +27,9 @@
 set(CFLAGS)
 list(APPEND CFLAGS
 	-O2
+	-fstack-protector-strong
+	-fPIE
+	-D_FORTIFY_SOURCE=2
 	-Wall
 	-Wno-pointer-sign
 	-Wno-deprecated-declarations
@@ -41,6 +44,9 @@
 )
 
 target_compile_options(ikectl PRIVATE ${CFLAGS})
+if(HAVE_LD_Z)
+	target_link_options(ikectl PRIVATE "LINKER:-z,relro,-z,now")
+endif()
 
 target_include_directories(ikectl
 	PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}

=== iked/CMakeLists.txt ===
--- 
+++ 
@@ -25,6 +25,9 @@
 set(CFLAGS)
 list(APPEND CFLAGS
 	-O2
+	-fstack-protector-strong
+	-fPIE
+	-D_FORTIFY_SOURCE=2
 	-Wall
 	-Wno-pointer-sign
 	-Wno-deprecated-declarations
@@ -98,16 +101,32 @@
 
 target_compile_options(iked PRIVATE ${CFLAGS})
 target_compile_options(iked-shared PRIVATE ${CFLAGS})
+if(HAVE_LD_Z)
+	target_link_options(iked PRIVATE "LINKER:-z,relro,-z,now")
+endif()
 
 target_include_directories(iked PRIVATE ${INC_DIRS})
 target_include_directories(iked-shared PRIVATE ${INC_DIRS})
 
-target_link_libraries(iked-shared
-	PRIVATE util event crypto ssl compat
-)
-target_link_libraries(iked
-	PRIVATE util event crypto ssl compat iked-shared
-)
+if(CLUSTERFUZZ)
+	target_link_libraries(iked-shared
+        	"-lm -Wl,-Bstatic -lssl -lcrypto -levent -Wl,-Bdynamic" compat
+	)
+else()
+	target_link_libraries(iked-shared
+		PRIVATE util event crypto ssl compat
+	)
+endif()
+
+if(WITH_APPARMOR)
+	target_link_libraries(iked
+		PRIVATE util event crypto ssl compat iked-shared apparmor
+	)
+else()
+	target_link_libraries(iked
+		PRIVATE util event crypto ssl compat iked-shared
+	)
+endif()
 
 add_custom_command(
 	OUTPUT parse.c
@@ -138,6 +157,11 @@
 )
 install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/iked.conf.5 DESTINATION ${CMAKE_INSTALL_MANDIR}/man5/)
 install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/iked.8 DESTINATION ${CMAKE_INSTALL_MANDIR}/man8/)
+if(WITH_APPARMOR)
+	install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/../contrib/iked.apparmor
+		DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/apparmor.d/
+		RENAME usr.sbin.iked)
+endif()
 install(DIRECTORY DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/iked/ca)
 install(DIRECTORY DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/iked/certs)
 install(DIRECTORY DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/iked/crls)

=== regress/parser-libfuzzer/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,4 @@
+# Copyright (c) 2022 David Linder
 # Copyright (c) 2020-2021 Tobias Heider <tobhe@openbsd.org>
 #
 # Permission to use, copy, modify, and distribute this software for any
@@ -12,11 +13,6 @@
 # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 
-set(CMAKE_C_COMPILER clang)
-
-# address-sanitizer not working on OpenBSD
-set(CMAKE_C_FLAGS "-g -O1 -fsanitize=fuzzer,address")
-set(CMAKE_EXE_LINKER_FLAGS "-fsanitize=fuzzer,address")
 
 set(SRCS)
 list(APPEND SRCS
@@ -30,12 +26,26 @@
 	PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/../../iked
 )
 
-target_link_libraries(test_libfuzzer
-	PRIVATE util event crypto ssl compat iked-shared
-)
+# when using clusterfuzz we need static linking and clusterfuzz' compiler arguments
+if(CLUSTERFUZZ)
+	set(CMAKE_C_COMPILER $ENV{CC})
+	set(CMAKE_C_FLAGS $ENV{CFLAGS})
+	set(CMAKE_EXE_LINKER_FLAGS $ENV{CFLAGS})
+	target_link_libraries(test_libfuzzer
+		"-lm -Wl,-Bstatic -lssl -lcrypto -levent" compat iked-shared $ENV{LIB_FUZZING_ENGINE}
+	)
+else()
+	set(CMAKE_C_COMPILER clang)
+	# address-sanitizer not working on OpenBSD
+	set(CMAKE_C_FLAGS "-g -O1 -fsanitize=fuzzer,address")
+	set(CMAKE_EXE_LINKER_FLAGS "-fsanitize=fuzzer,address")
+	target_link_libraries(test_libfuzzer
+		PRIVATE event crypto ssl compat iked-shared
+	)
+	file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/corpus)
+	configure_file(run_test.sh run_test.sh COPYONLY)
+	configure_file(fuzz.dict fuzz.dict COPYONLY)
+endif()
 
 target_compile_options(test_libfuzzer PRIVATE ${CFLAGS})
 
-file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/corpus)
-configure_file(run_test.sh run_test.sh COPYONLY)
-configure_file(fuzz.dict fuzz.dict COPYONLY)

=== regress/test_helper/Makefile ===
#	$OpenBSD: Makefile,v 1.1 2017/05/29 20:59:32 markus Exp $

LIB=	test_helper
SRCS=	test_helper.c

DEBUGLIBS= no
NOPROFILE= yes
NOPIC=	yes

install:
	@echo -n

.include <bsd.lib.mk>

=== debian/changelog ===
openiked (7.2-1) unstable; urgency=medium

  * New upstream release.

  [ Tobias Heider ]
  * Add myself to Uploaders.

  [ Debian Janitor ]
  * debian/copyright: use spaces rather than tabs to start continuation lines.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Update standards version to 4.6.1, no changes needed.

  [ Ryan Kavanagh ]
  * Update lintian overrides to deal with renamed tags

 -- Ryan Kavanagh <rak@debian.org>  Tue, 10 Jan 2023 16:02:50 -0500

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,14 @@
 Source: openiked
 Section: net
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Ryan Kavanagh <rak@debian.org>
+Maintainer: Ryan Kavanagh <rak@debian.org>
+Uploaders: Tobias Heider <me@tobhe.de>
 Build-Depends: bison,
                cmake,
                debhelper-compat (= 13),
                libevent-dev,
                libssl-dev,
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://www.openiked.org/
 Vcs-Browser: https://salsa.debian.org/debian/openiked
 Vcs-Git: https://salsa.debian.org/debian/openiked.git -b debian/unstable

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cd obj-$(DEB_HOST_GNU_TYPE)/regress/dh && ./dhtest
endif

override_dh_fixperms:
	dh_fixperms
	chmod 700 debian/openiked/etc/iked/private
	chmod 600 debian/openiked/etc/iked.conf
